// définition des différentes grandeurs
unsigned long origine_temps;
float C ;
float R ;
float Tau;

void setup() {
  pinMode(7, OUTPUT); // alimentation branchée sur l'entrée 7 
  Serial.begin(9600);
  // dans un premier temps, on s'assure que le condensateur est complètement déchargé
  Serial.println("Preparation du condensateur");
  digitalWrite(7,LOW);// alimentation à 0V
  delay(5000); // delai au cours duquel l'alimentation est maintenue à 0V, on prend ici 5000 ms
  
  // dans un deuxième temps, charge du condensateur
  Serial.println("Charge de condensateur");
  digitalWrite(7,HIGH); // alimentation à 5V (1023 bits)
  origine_temps = millis(); // définition de l'origine des temps à l'aide de la fonction
                            // millis() qui renvoie la date en ms de l'horlorge interne d'Arduino
                            // prise à partir de sa mise sous tension
  while(analogRead(A0)< 0.63*1023){
  }
  //affichage de la constante de temps
  Tau = millis() - origine_temps;
  Serial.print("Tau = ");
  Serial.print(Tau);
  Serial.println(" ms");
  R = 9700000 ;
  C = (Tau/R)*1000000 ; //Calcul de C en nanoFarad
  Serial.print("C = ");
  Serial.print(C);
  Serial.println(" nanoFarad");
} 
void loop() {
}
